// Code generated by mockery v2.20.0. DO NOT EDIT.

package mockclients

import (
	context "context"
	io "io"

	mock "github.com/stretchr/testify/mock"

	types "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg/types"
)

// ConfigurationVersion is an autogenerated mock type for the ConfigurationVersion type
type ConfigurationVersion struct {
	mock.Mock
}

// CreateConfigurationVersion provides a mock function with given fields: ctx, input
func (_m *ConfigurationVersion) CreateConfigurationVersion(ctx context.Context, input *types.CreateConfigurationVersionInput) (*types.ConfigurationVersion, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.ConfigurationVersion
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateConfigurationVersionInput) (*types.ConfigurationVersion, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateConfigurationVersionInput) *types.ConfigurationVersion); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.ConfigurationVersion)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateConfigurationVersionInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DownloadConfigurationVersion provides a mock function with given fields: ctx, input, writer
func (_m *ConfigurationVersion) DownloadConfigurationVersion(ctx context.Context, input *types.GetConfigurationVersionInput, writer io.WriterAt) error {
	ret := _m.Called(ctx, input, writer)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetConfigurationVersionInput, io.WriterAt) error); ok {
		r0 = rf(ctx, input, writer)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetConfigurationVersion provides a mock function with given fields: ctx, input
func (_m *ConfigurationVersion) GetConfigurationVersion(ctx context.Context, input *types.GetConfigurationVersionInput) (*types.ConfigurationVersion, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.ConfigurationVersion
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetConfigurationVersionInput) (*types.ConfigurationVersion, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetConfigurationVersionInput) *types.ConfigurationVersion); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.ConfigurationVersion)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetConfigurationVersionInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UploadConfigurationVersion provides a mock function with given fields: ctx, input
func (_m *ConfigurationVersion) UploadConfigurationVersion(ctx context.Context, input *types.UploadConfigurationVersionInput) error {
	ret := _m.Called(ctx, input)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.UploadConfigurationVersionInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

type mockConstructorTestingTNewConfigurationVersion interface {
	mock.TestingT
	Cleanup(func())
}

// NewConfigurationVersion creates a new instance of ConfigurationVersion. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewConfigurationVersion(t mockConstructorTestingTNewConfigurationVersion) *ConfigurationVersion {
	mock := &ConfigurationVersion{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
